function GISCitySuggest(){
	this.handlers = {};
	this.delay = 500;
	this.minLength = 2;
	this.url = '/ajax/avia_search/';
	this.loadingClass = 'o';
	this.result_tpl = "'<span class=\"city @kind\">@city</span>'+('@district'!==''?' - @district':'')+' - @country'";
	this.itemsLength = 7;
}
GISCitySuggest.prototype.setCallback = function(event, handler){
	this.handlers[event] = handler;
}
GISCitySuggest.prototype.init = function(whatID, lang){
	var inputWhat = $(whatID);
	inputWhat.autocomplete({
		delay: this.delay,
		minLength: this.minLength,
		source: $.proxy(function(request, response){
			var data = {startsWith: request.term, lang: lang, search_all: 1};			
			$.ajax({
				crossDomain: true,
				type: "GET",
				url: this.url,
				dataType: "xml",
				data: data,
				context: {obj:this},
				success: $.proxy(function(data){
					var map = $.map($(data).find('item'), $.proxy(function(item, i){
						item = $(item);
						if (i == this.itemsLength-1) return;
						if (item.attr('kind') == 'T') item.attr('kind', 'M');
						var text = this.result_tpl.replace(/@kind/g, item.attr('kind')).replace(/@city/g, item.attr('n')).replace(/@country/g, item.attr('country_name')).replace(/@district/g, (item.attr('district_name')?item.attr('district_name')+', ':''));
						var res = {
							label: text.replace(
                    new RegExp(
                        "(?![^&;]+;)(?!<[^<>]*)(" +
                        $.ui.autocomplete.escapeRegex(request.term) +
                        ")(?![^<>]*>)(?![^&;]+;)", "gi"
                    ), "<strong>$1</strong>" ),
							value: item.attr('n'),
							id: item.attr('id'),
							item: item,
							option: this
						};
						return (i <= this.itemsLength)?res:null;
					}, this));
					response(map);
				}, this),
				error: $.proxy(function(){
					if ($('.options').css('display') == 'none')  inputWhat.autocomplete("disable");
				}, this)			
			});
		}, this),
		select: $.proxy(function(event, ui){
			if(this.handlers['select']) {
				this.handlers['select'](event, ui);
			}
		}, this)
	}).removeClass('ui-corner-all ui-autocomplete-input')
		.data('ui-autocomplete')._renderItem = function(ul, item){
		ul.removeClass('ui-corner-all');
		return $('<li class="ui-li"></li>')
			.data('item.autocomplete', item )
			.append('<a>'+item.label+'</a>')
			.appendTo(ul);
	};
}