﻿function BgProc() {
	this.ver = null;
	this.dict = null;
	this.langs = null;
	this.params = null;
	this.updatetime = null;
	this.city = {};
	this.forecast = {};
	this.news = null;
	this.citiesUrl = null;
	this.forecastUrl = null;
	this.default_city_id = null;
	this.default_city_name = null;
	this.timeout = null;
	this.config = new Config();		
	this.storage = new Storage();
	this.lastRenderDate = null;
	this.isReloadApp = false;
	this.utc = {timer: null, delay: 30000, time: null, isFromLocalTime: false},
	this.init = function(callback) {	
		this.updatetime = 900000;
		this.langs = this.config.langs || ['ru', 'ua', 'lt', 'en'];
		this.citiesUrl = this.config.citiesUrl;
		this.forecastUrl = this.config.forecastUrl;
		this.ver = this.config.ver;		
		this.params = this.storage.getStorage('params') || this.config.params || {lang: 'ru', deg: 'C', press: 'mmHg', wind: 'm', 'updatetime': this.updatetime};							
		if (this.params.updatetime < this.updatetime) this.params.updatetime = this.updatetime; //important!!!		
		this.dict = this.setDictFromLang(this.params.lang);					
		this.city = this.storage.getStorage('city') || this.config.city;										
		if(this.city && callback) callback();
		else this.setDefaultCity(callback);
		if (!this.storage.getStorage('isFirstRun'))  {
			ga('send', 'event', 'Counter', 'Intalls');
			var OperationSystem = 'undefined';
			if(navigator.userAgent.indexOf("Windows NT 6.0")!=-1) OperationSystem = "NT 6.0"; 
 			if(navigator.userAgent.indexOf("Windows NT 6.1")!=-1) OperationSystem = "NT 6.1"; 
 			if(navigator.userAgent.indexOf("Windows NT 6.2")!=-1) OperationSystem = "NT 6.2";
 			ga('send', 'event', 'Env', 'OS', OperationSystem, 1); 
 			ga('send', 'event', 'Env', 'Resolution', window.screen.width+'x'+window.screen.height, 1);
			this.storage.setStorage('isFirstRun', 0);
		}			
	}
	this.setDefaultCity = function(callback) {
		var data = {mode: 'ip', nocache: '1'};
		$.ajax({
			crossDomain: true,
			type: "GET",
			url: this.citiesUrl,
			data: data,
			dataType: "xml",
			success: $.proxy(function(data, status, xhr) {
				var f = $(data).find('item');
				if (f.length>0) {
					this.city = {id: $(f[0]).attr('id'), name: $(f[0]).attr('n')};
				}
			}, this),
			complete: $.proxy(function() {
				this.storage.setStorage('city', this.city);
				this.storage.setStorage('params', this.params);
				if (callback) callback();
			}, this)
		});			
	}
	this.getFrc = function(callback) {	
		var context = this;	
		this.forecast = this.storage.getStorage('frc') || {};
		var date = this.forecast.cur_time || 0;
		clearTimeout(this.timeout);		
		this.timeout  = null;	
		if (
				typeof this.forecast.fact == 'undefined' ||
				typeof this.forecast.forecast == 'undefined' ||
				typeof this.forecast.cur_time == 'undefined' ||
				this.forecast.cur_time == 0 ||
				Math.abs(new Date().getTime()-date) > this.params.updatetime
		){				
			$.ajax({
				crossDomain: true,
				type: "GET",
				url: this.forecastUrl,
				data: {city: this.city.id, all_langs: 1, ver: this.ver},
				dataType: "xml",
				success: $.proxy(function(data, status, xhr) {
					var f = $(data).find('location');
					try {
						this.city.name = {};
						this.city.name_i = {};
						$.each(this.langs, $.proxy(function(index) {
							this.city.name_i[this.langs[index]] = f.attr('name_'+this.langs[index]);
							this.city.name[this.langs[index]] = f.attr('name_r_'+this.langs[index]);
						}, this));
						this.city.tzone = f.attr('tzone')*60000;
						this.city.url = f.attr('url');
						this.forecast.fact = this.parseData($(f[0]), 'fact');
						this.forecast.forecast = this.parseData($(f[0]), 'forecast');
						this.forecast.cur_time = new Date().getTime();		
						this.storage.setStorage('frc', this.forecast);
						this.storage.setStorage('city', this.city);
						if(callback) callback();
						this.timeout = setTimeout(function(){context.getFrc(callback)}, 30000);
						this.lastRenderDate = new Date();
					}
					catch(e) {}												
				}, this),
				error: $.proxy(function (xhr, ajaxOptions, thrownError) {
					this.timeout = setTimeout(function(){context.getFrc(callback)}, 30000);
				}, this)
			});
		}
		else {		
			if(callback) callback();						
			this.timeout = setTimeout(function(){context.getFrc(callback)}, 30000);
		}
	}
	this.parseData = function(data, item) {
		var d = [];
		var descr = [];
		$(data).find(item).each($.proxy(function(index, obj){
			var f = $(obj).find('values');
			$.each(langs, function(num) {
				descr[langs[num]] = f.attr('descr_'+langs[num]);
			});
			this.data = {
			  valid: $(obj).attr('valid'),
				t:f.attr('t'),
				t_feels:f.attr('hi'),																								
				hi:f.attr('hi'),
				p:f.attr('p'),
				cl:f.attr('cl') == 0?'':('c'+(parseInt(f.attr('cl'), 10)+1)),
				pt:f.attr('pt') == 0?'':(f.attr('pt') == 1?'r':'s'),
				pr:f.attr('pr') == 0?'':f.attr('pr'),			
				st:f.attr('ts') == 0?'':'st',			
				wd:f.attr('wd') == 0?1:f.attr('wd'),
				ws:f.attr('ws'),
				hum:f.attr('hum'),
				icon: parseInt(f.attr('cl'), 10)+1<4?(f.attr('icon').indexOf('sun')>-1?'d':'n'):''
			};
			d.push(this.data);
		}, this));
		return d;
	}
	this.setDictFromLang = function(lang) {
		return dict[lang] || dict['ru'];
	}
  this.getUTCTime = function(callback) {
  	if (this.lastRenderDate && Math.abs(new Date().getTime()-this.lastRenderDate.getTime())>this.updatetime+60000) this.utc.time = null;	  	
  	if (!this.utc.time || this.utc.isFromLocalTime) {
  		var context = this;
  		var url = 'http://time.gismeteo.ru/?r='+Math.random();
	    $.getJSON(url, function(o){
	    		clearInterval(context.utc.timer);
	    		context.utc.timer = null;
	    		context.utc.time = new Date();
	    		context.utc.time.setTime(o.dateString);
	    		context.utc.isFromLocalTime = false;
	    })
	    .error(function() {context.utc.time = context.getUtcTimeFromLocalTime(); context.utc.isFromLocalTime = true;})
	    .complete(function(){
	    	clearInterval(context.utc.timer);
	    	context.utc.timer = null;	    	
	    	try {
	    		context.utc.timer = setInterval(function() {context.utc.time = new Date(context.utc.time.getTime()+context.utc.delay);}, context.utc.delay);
	    	}
	    	catch (err) {
	    		context.utc.time = context.getUtcTimeFromLocalTime(); context.utc.isFromLocalTime = true;
	    		context.utc.timer = setInterval(function() {context.utc.time = new Date(context.utc.time.getTime()+context.utc.delay);}, context.utc.delay);	    			
	    	}
	    	if (callback) callback();	       	
	    });  		
		} 
		else { 			
			if (callback) callback();
		}				
  }
	this.getUtcTimeFromLocalTime = function(){
		var now = new Date();
		var now_utc = new Date(now.getUTCFullYear(), now.getUTCMonth(), now.getUTCDate(),  now.getUTCHours(), now.getUTCMinutes(), now.getUTCSeconds());
		return now_utc; 
  }
  this.checkVersion = function(isCheck, callback) {
  	if (isCheck === false) {
  		callback();
  		return;
  	}
  	var v = this.storage.getStorage('version');
  	if (v) { 
  		if ((new Date()).getTime()- v.checkTime > 60000*60) getVersion(this, callback);
  		else callback();
  	}
  	else getVersion(this, callback);
  		
  	function getVersion(_this, callback) {
			$.ajax({
				crossDomain: true,
				type: "GET",
				url: _this.config.versionUrl,
				dataType: "json",
				success: function(data, status, xhr) {
					var v = {ga: data.ver, checkTime: new Date().getTime()};
					_this.storage.setStorage('version', v);
					v = v.ga.split('.');
					var appVesion = _this.ver.split('.'); 
					if (v[0] > appVesion[0]) {
						_this.isReloadApp = true;
					}
				},
				complete: $.proxy(function() {
					if (callback) callback();
				}, _this) 
			});  		
  	} 			
  }     		
}

function parseISO8601Date(s){
 
  // parenthese matches:
  // year month day    hours minutes seconds  
  // dotmilliseconds 
  // tzstring plusminus hours minutes
  var re = /(\d{4})-(\d\d)-(\d\d)T(\d\d):(\d\d):(\d\d)(\.\d+)?(Z|([+-])(\d\d):(\d\d))/;
 
  var d = [];
  d = s.match(re);
 
  // "2010-12-07T11:00:00.000-09:00" parses to:
  //  ["2010-12-07T11:00:00.000-09:00", "2010", "12", "07", "11",
  //     "00", "00", ".000", "-09:00", "-", "09", "00"]
  // "2010-12-07T11:00:00.000Z" parses to:
  //  ["2010-12-07T11:00:00.000Z",      "2010", "12", "07", "11", 
  //     "00", "00", ".000", "Z", undefined, undefined, undefined]
 
  if (! d) {
    throw "Couldn't parse ISO 8601 date string '" + s + "'";
  }
 
  // parse strings, leading zeros into proper ints
  var a = [1,2,3,4,5,6,10,11];
  for (var i in a) {
    d[a[i]] = parseInt(d[a[i]], 10);
  }
  d[7] = parseFloat(d[7]);
 
  // Date.UTC(year, month[, date[, hrs[, min[, sec[, ms]]]]])
  // note that month is 0-11, not 1-12
  // see https://developer.mozilla.org/en/JavaScript/Reference/Global_Objects/Date/UTC
  var ms = Date.UTC(d[1], d[2] - 1, d[3], d[4], d[5], d[6]);
 
  // if there are milliseconds, add them
  if (d[7] > 0) {  
    ms += Math.round(d[7] * 1000);
  }
 
  // if there's a timezone, calculate it
  if (d[8] != "Z" && d[10]) {
    var offset = d[10] * 60 * 60 * 1000;
    if (d[11]) {
      offset += d[11] * 60 * 1000;
    }
    if (d[9] == "+") {
      ms -= offset;
    }
    else {
      ms += offset;
    }
  }
 
  return new Date(ms);
}

function writeLog(str) {
		var log = document.getElementById('log');
		if (log) {
			//var content = log.innerHTML;
			//var now = new Date();
			//str = '<p>' + now.toString("dd.mm.yyyy hh:mm:ss")+' '+ strtype.toUpperCase() + ': ' + (typeof str != 'undefined'?str:'') + '</p>';
			//str = typeof str != 'undefined'?str:'';			
			log.innerHTML = str;
		}
}
	