var langs = new Array('ru', 'en', 'ua', 'lt');

var dict = {
	ru: {
		lang: "ru",
		domain: "ru",
	 	default_city_id: 4368,
		default_city_name: "Москва",
		weekdays: {w0: 'Вc', w1: 'Пн', w2: 'Вт', w3: 'Ср', w4: 'Чт', w5: 'Пт', w6: 'Сб'},
		wdirs: {w9: "Штиль", w1: "cев.", w2: "св", w3: "вост.", w4: "юв", w5: "южн.", w6: "юз", w7: "зап.", w8: "сз"},
		all_weekdays: {w0: 'Воскресенье', w1: 'Понедельник', w2: 'Вторник', w3: 'Среда', w4: 'Четверг', w5: 'Пятница', w6: 'Суббота'},		
		monthes: {m0: "янвaря", m1: "февраля", m2: "марта", m3: "апреля", m4: "мая", m5: "июня", m6: "июля", m7: "августа", m8: "сентября", m9: "октября", m10: "ноября", m11: "декабря"},
		minMonthes: {m0: "янв", m1: "фев", m2: "март", m3: "апр", m4: "мая", m5: "июн", m6: "июл", m7: "авг", m8: "сент", m9: "окт", m10: "ноя", m11: "дек"},
		phenomens: {c: 'Ясно', c2: 'Малооблачно', c3: 'Облачно', c4: 'Пасмурно', pr0: '', pr1: 'небольшой', pr2: '', pr3: 'сильный', r: 'дождь', s: 'снег', st: 'гроза'},
		params: {C: 'C', F: 'F', mmHg: {unit: 'мм',  unit_part2: 'рт. ст.'}, hPa: {unit:'гПа', unit_part2:''}, m:'м/с', km:'км/ч'},		
		legends: {location: 'Местоположение', units: 'Единицы измерения', language: 'Язык (Language)', wind: 'Ветер', pressure: 'Давление', humidity: 'Влажн.', feel: 'Ощущ.', dt: 'Факт за'},
		now: 'Сейчас',
		newVersion: 'Доступна новая версия',
		links: {link10: 'Прогноз погоды на 10 дней'}
	},
	ua: {
	 	lang: "ua",
	 	domain: "ua",
	 	default_city_id: "4944",
		default_city_name: "Київ",
		weekdays: {w0: 'Нд', w1: 'Пн', w2: 'Вт', w3: 'Ср', w4: 'Чт', w5: 'Пт', w6: 'Сб'},
		all_weekdays: {w0: 'Неділя', w1: 'Понеділок', w2: 'Вівторок', w3: 'Середа', w4: 'Четвер', w5: "П'ятниця", w6: 'Субота'},
		wdirs: {w9:"Штиль", w1:"Пн", w2:"ПнС", w3:"С", w4:"ПдС", w5:"Пд", w6:"ПдЗ", w7:"З", w8:"ПнЗ"},		
		monthes: {m0: "січня", m1: "лютого", m2: "березня", m3: "квітня", m4: "травня", m5: "червня", m6: "липня", m7: "серпня", m8: "вересня", m9: "жовтня", m10: "листопада", m11: "грудня"},
		minMonthes: {m0: "січ", m1: "лют", m2: "бер", m3: "кві", m4: "тра", m5: "чер", m6: "лип", m7: "сер", m8: "вер", m9: "жов", m10: "лис", m11: "гру"},
	 	phenomens: {c: 'Ясно', c2: 'Слабка хмарність', c3: 'Хмарно', c4: 'Сильна хмарність', pr0: '', pr1: 'невеликий', pr2: '', pr3: 'сильний', r: 'дощ', s: 'сніг', st: 'гроза'},
		params: {C: 'C', F: 'F', mmHg: {unit: 'мм',  unit_part2: 'рт. ст.'}, hPa: {unit:'гПа', unit_part2:''}, m:'м/с', km:'км/год'},		
		legends: {location: 'Місця розташування', units: 'Одиниці виміру', language: 'Mова (Language)', wind: 'Вітер', pressure: 'Атм. тиск', humidity: 'Волог.', feel: 'Відчув.', dt: ''},		
		now: 'Зараз',
		newVersion: 'Доступна нова версія',
		links: {link10: 'Прогноз погоди на 2 тижні'}						
	},
	lt: {
		lang: "lt",
		domain: "lt",
	 	default_city_id: "4230",	
		default_city_name: "Vilniaus",	 	
		weekdays: {w0: 'Sk', w1: 'Pr', w2: 'An', w3: 'Tr', w4: 'Kt', w5: "Pn", w6: 'Št'},
		all_weekdays: {w0: 'Sekmadienis', w1: 'Pirmadienis', w2: 'Antradienis', w3: 'Trečiadienis', w4: 'Ketvirtadienis', w5: "Penktadienis", w6: 'Šeštadienis'},
		wdirs: {w9:"Štilis", w1:"Š", w2:"ŠR", w3:"R", w4:"PR", w5:"P", w6:"PV", w7:"V", w8:"ŠV"},			
		monthes: {m0: "sausio", m1: "vasario", m2: "kovo", m3: "balandžio", m4: "gegužės", m5: "birželio", m6: "liepos", m7: "rugpjūčio", m8: "rugsėjo", m9: "spalio", m10: "lapkričio", m11: "gruodzio"},
		minMonthes: {m0: "saus", m1: "vas", m2: "kov", m3: "bal", m4: "geg", m5: "birž", m6: "liep", m7: "rugpj", m8: "rugs", m9: "spal", m10: "lapkr", m11: "gruod"},
		phenomens: {c: 'Giedra', c2: 'Mažas debesuotumas', c3: 'Debesuota', c4: 'Didelis debesuotumas', pr0: '', pr1: 'mažas', pr2: '', pr3: 'stiprus', r: 'lietus', s: 'sniegas', st: 'perkūnija'},	
		params: {C: 'C', F: 'F', mmHg: {unit: 'mmHg',  unit_part2: ''}, hPa: {unit:'hPa', unit_part2:''}, m:'m/s', km:'km/h'},		
		legends: {location: 'Vieta', units: 'Vienetų', language: 'Kalba (Language)', wind: 'Vėjas', pressure: 'Atm. slėgis', humidity: 'Drėgn.', feel: 'Pojūtis', dt: ''},		
		now: 'Dabar',
		newVersion: 'Nauja versija',
		links: {link10: 'Orų prognozė 2 savaites'}											 										
	},
	en: {
		lang: "en",
	 	domain: "com",	
	 	default_city_id: "4368", 
		default_city_name: "Moscow",	 		
		default_city_name_r: "in Moscow",		
		weekdays: {w0: 'Su', w1: 'Mo', w2: 'Tu', w3: 'We', w4: 'Th', w5: "Fr", w6: 'Sa'},		
		all_weekdays: {w0: 'Sunday', w1: 'Monday', w2: 'Tuesday', w3: 'Wednesday', w4: 'Thursday', w5: "Friday", w6: 'Saturday'},	
		wdirs: {w9: "Calm", w1: 'N', w2: 'NE', w3: 'E', w4: 'SE', w5: 'S', w6: 'SW', w7: 'W', w8: 'NW'},				
		monthes: {m0: "January", m1: "February", m2: "March", m3: "April", m4: "May", m5: "June", m6: "July", m7: "August", m8: "September", m9: "October", m10: "November", m11: "December"},
		minMonthes: {m0: "jan", m1: "feb", m2: "mar", m3: "apr", m4: "may", m5: "jun", m6: "jul", m7: "aug", m8: "sep", m9: "oct", m10: "nov", m11: "dec"},
		phenomens: {c: 'Fair', c2: 'Partly cloudy', c3: 'Cloudy', c4: 'Mainly cloudy', pr0: '', pr1: 'small', pr2: '', pr3: 'heavy', r: 'rain', s: 'snow', st: 'thunder-storm'},	
		params: {C: 'C', F: 'F', mmHg: {unit: 'mmHg',  unit_part2: ''}, hPa: {unit:'hPa', unit_part2:''}, m:'m/s', km:'km/h'},		
		legends: ['Location', 'Temperature', 'Appearance'],
		legends: {location: 'Location', units: 'Units', language: 'Language', wind: 'Wind', pressure: 'Atm. pressure', humidity: 'Hum.', feel: 'Feel', dt: ''},			
		now: 'Now',
		newVersion: 'A new version',
		links: {link10: 'Weather Forecast for 2 weeks'}																		
	}
}