﻿var suggest = null;

function Opt() {
	this.citiesUrl = null;
	this.params = {};
	this.dict = {};
	this.city = {};
	this.langs = null;
	this.storage = new Storage();
	this.config = new Config();
	this.init = function() {
		this.citiesUrl = this.config.citiesUrl;
		this.langs = this.config.langs || ['ru', 'ua', 'lt', 'en'];
		this.params = this.storage.getStorage('params') || this.config.params || {lang: 'ru', deg: 'C', press: 'mmHg', wind: 'm', 'updatetime': this.updatetime};
		this.city = this.storage.getStorage('city') || this.config.city;
		this.initSuggest();
		System.Gadget.onSettingsClosing = $.proxy(function(event) {
			if (event.closeAction == event.Action.commit) {	
				var id = this.storage.getStorage('city');
				if (this.city.id != id) this.storage.setStorage('frc', null);		
				this.storage.setStorage('city', this.city);
				this.storage.setStorage('params', this.params);	
			}
		}, this);
		$('select').change($.proxy(function() {
			this.params.lang = $('select :selected').val();
			this.renderOptions();		
		},this));
		this.renderOptions();				
	}
	this.renderOptions = function() {
		this.dict = this.setDictFromLang(this.params.lang);		
		$('.title:eq(0)').html(this.dict.legends.location);
		$('.title:eq(1)').html(this.dict.legends.units);
		$('.title:eq(2)').html(this.dict.legends.language);
		$('label:eq(2) span').html(this.dict.params.mmHg.unit+' '+this.dict.params.mmHg.unit_part2);
		$('label:eq(3) span').html(this.dict.params.hPa.unit+this.dict.params.hPa.unit_part2);
		$('label:eq(4) span').html(this.dict.params.m);
		$('label:eq(5) span').html(this.dict.params.km);
		if (typeof this.city.name_i[this.params.lang] !== 'undefined')
			$('input[name="location"]').attr('placeholder', this.city.name_i[this.params.lang]);
		$.each(this.params, function(key, val) {
			$('input[name='+key+'][value='+val+']').attr('checked', 'checked');
		});
		$("select option[value='"+this.params.lang+"']").prop('selected', true);
		var context = this;
		$('input[type=radio]').change(function() {
				context.params[$(this).attr('name')] =($(this).filter(":checked").val());
		});
		suggest.init($('.location'), this.params.lang);
	}
	this.setDictFromLang = function(lang) {
		return dict[lang] || dict['ru'];
	}	
	this.initSuggest = function() {
	 	suggest = new GISCitySuggest();
		suggest.url = this.citiesUrl;
		suggest.minLength = 2;
		suggest.result_tpl = "<div class=\"icon @kind\"></div><div class=\"city\">@city</div><div class=\"dc\">@district@country</div>";
		suggest.loadingClass = 'o';
		suggest.setCallback('select', $.proxy(function(event, ui){	
			var data = $(ui.item).attr('item');		
			data = $(data);
			this.city = {id: data.attr('id'), name: data.attr('n')};
			var city = this.city;							
			setTimeout(
				function() {
					$('input[name="location"]').removeAttr('value', '').attr('placeholder', city.name).blur();
				}, 
				50
			);			
		}, this));
	}
}

$(function(){
		var option  = new Opt();
		option.init();
		$.support.cors = true;
	
	$('.location').bind('keyup', function() {
		$(this).attr('placeholder', '');	
	});
	$('.location').bind('click', function() {
		if ($(this).attr('placeholder') == '') $(this).select();
	});	

});

	function writeLog(strtype, str) {
		var log = document.getElementById('content');
		if (log) {
			var content = log.innerHTML;
			var now = new Date();
			str = '<p>' /*+ now.toString("dd.mm.yyyy hh:mm:ss")+' '*/+ strtype.toUpperCase() + ': ' + (typeof str != 'undefined'?str:'') + '</p>';
			log.innerHTML = str;
		}
	}	