﻿
var templates = {
	tpls: null,
	loadTpl: function(template, data) {
  	return template.replace(/\{([\w\.]*)\}/g, function (str, key) {
    	var keys = key.split("."), value = data[keys.shift()];
      $.each(keys, function () { value = value[this]; });
      return (value === null || value === undefined) ? "" : ($.isArray(value) ? value.join('') : value);
    });
  },
  data: {}
};

function Render(docObj, data) {
	this.docObj = docObj || document;
	this.config = new Config();
	this.storage = new Storage();
	this.dict = data.dict; 
	this.city = data.city || null;
	this.params = data.params || null;
	this.forecast = data.forecast;
	this.template = data.template || 'dock'; 
	this.templates = templates;
	this.utc = data.utc;
	this.rec = [];
	this.step = 1;
	this.minT =  100;
	this.maxT =  -100;
	this.isReloadApp = data.isReloadApp;
	this.writeLog = function(strtype ,str) {
		var log = this.docObj.getElementById('log');
		if (log) {
			var content = log.innerHTML;
			var now = new Date();
			str = '<p>' + now.toString("dd.mm.yyyy hh:mm:ss")+' '+ strtype.toUpperCase() + ': ' + (typeof str != 'undefined'?str:'') + '</p>';
			log.innerText = str;
		}
	}
	this.init = function(callback) {
		this.city = this.city || this.config.city;
		this.params = this.params || this.config.params;
		this.forecast = this.forecast || {};
		if(callback) callback();		
	}
	this.renderGadget = function() {
		var content = this.docObj.getElementById('content');
		content.innerHTML = '';			
		switch(this.template) {
			case 'dock':
					$('.preloader').hide();	
				$('.dock.logo').show();
				if (this.templates.tpls.dock == null) return;								
				var template = this.templates.tpls.dock.innerHTML;
				//this.templates.data['city'] = 'Петропавловск-Камчатский';				
				this.templates.data['city'] = this.city.name_i[this.params.lang];			
				var date = this.getCurrentDatetime(this.city.tzone);	
				this.templates.data['hh'] = date.hour;
				this.templates.data['ii'] = date.minutes;	
				this.templates.data['t'] = (this.params.deg == 'C'?this.forecast.fact[0].t:Math.round(this.forecast.fact[0].t*1.8+32));			
				this.templates.data['t'] = this.forecast.fact[0].t>0?('+'+this.templates.data['t']):('&minus;'+Math.abs(this.templates.data['t']));
				this.getPhotoPict(this.forecast.fact[0]);					
				content.innerHTML = this.templates.loadTpl(template, this.templates.data);
				var city = this.city;
				city.url = (city.url.indexOf('http://')>-1?this.city.url:('http://beta.gismeteo.ru'+city.url));
				$('.logo img')
					.unbind('click')
					.bind('click', $.proxy(function(){
						ga('send', 'event', 'Counter', 'LogoClick');
						window.location = (this.params.lang!=='ru'?('http://www.gismeteo.'+this.dict.domain):city.url)+'?from=w7'
					}, this))
					.unbind('mouseover')
					.unbind('mouseout')
					.bind('mouseover', function() {$('.city_title').css('color', '#999');  $('.city_title span').css('border-bottom', '1px dotted #999');$(this).attr('src', '../../images/logo_dock_hover.png')})
					.bind('mouseout', function() {$('.city_title').css('color', 'white'); $('.city_title span').css('border-bottom', '1px dotted white'); $(this).attr('src', '../../images/logo_dock.png')});
						
				$('#content')
					.unbind('mouseover')
					.unbind('mouseout')
					.bind('mouseover', function() {$('.city_title').css('color', 'white'); $('.city_title span').css('border-bottom', '1px dotted white')})
					.bind('mouseout', function() {$('.city_title').css('color', '#999'); $('.city_title span').css('border-bottom', '1px dotted #999')});
											
			break;
			default:
				if (this.template == 'undock') {
					$('.dock.logo').hide();
					$('.preloader').hide();	
				}
				this.templates.data = {};
				var template = this.templates.tpls.undock.innerHTML;	
				this.renderCity();			
				this.renderFact();				
				this.renderForecast();					
				this.templates.data['link10'] = this.dict.links.link10;	
				var city = this.city;
				var url = (city.url.indexOf('http://')>-1?this.city.url:('http://beta.gismeteo.ru'+city.url));
				this.templates.data['href'] = (this.params.lang!=='ru'?('http://www.gismeteo.'+this.dict.domain+'/'+this.dict.lang+'/city/weekly/'+city.id):url)+'?from=w7';
				this.templates.data['href_link10'] = (this.params.lang!=='ru'?('http://www.gismeteo.'+this.dict.domain+'/'+this.dict.lang+'/city/weekly/'+city.id):url)+'?from=w7';
				this.templates.data['href_link'] = (this.params.lang!=='ru'?('http://www.gismeteo.'+this.dict.domain+'/'+this.dict.lang):this.getRootUrl(url))+'?from=w7';	
				content.innerHTML = this.templates.loadTpl(template, this.templates.data);
				this.setFrcTemperPos();				
				this.setColorGraph();			
				this.setGraph();
				if (this.isReloadApp) {
					if (!this.storage.getStorage('new_version_mini')) {
						this.docObj.getElementById('new_version_a').innerHTML = this.dict.newVersion;
						this.docObj.getElementById('new_version').style.display = 'block';
						var context = this;
						this.docObj.getElementById('x').onclick = function() {
							context.docObj.getElementById('new_version').style.display = 'none';
							context.docObj.getElementById('new_version_mini').style.display = 'block';
							context.docObj.getElementById('new_version_mini_a').innerHTML = context.dict.newVersion;
							context.storage.setStorage('new_version_mini', true);		
						}
					}
					else {
						this.docObj.getElementById('new_version_mini_a').innerHTML = this.dict.newVersion;						
						this.docObj.getElementById('new_version_mini').style.display = 'block';
					}
				}
				else {
					this.storage.setStorage('new_version_mini', false);	
				}
				var o = this.docObj.getElementById('legend0');
				if (o) o.style.left =  o.offsetLeft - o.offsetWidth/2+'px';
				
			break;			
		}			
	}
	this.renderCity = function() {
		var template = this.templates.tpls.city.innerHTML;
		this.templates.data['now'] = this.dict.now;
		var city = this.city;
		var cityname = city.name[this.params.lang];
		//this.templates.data['name'] = cityname.slice(0, 1).toUpperCase() + cityname.slice(1);
		this.templates.data['name'] = cityname;
		var date = this.getCurrentDatetime(city.tzone);	
		this.templates.data['hh'] = date.hour;
		this.templates.data['ii'] = date.minutes;	
		this.templates.data['title'] = this.templates.loadTpl(template, this.templates.data); 			
	}	
	this.renderFact = function() {
		var template = this.templates.tpls.fact.innerHTML;	
		this.setTemplateData(this.forecast.fact[0], 'fact');
		var date = this.getDateFrc(this.forecast.fact[0].valid);	
		this.templates.data['date'] = date.time;
		this.templates.data['feel'] = this.dict.legends.feel;
		this.templates.data['wind'] = this.dict.legends.wind;
		this.templates.data['pressure'] = this.dict.legends.pressure;
		this.templates.data['humidity'] = this.dict.legends.humidity;
		this.templates.data['dt'] =	this.dict.legends.dt;					
		this.templates.data['fact'] = this.templates.loadTpl(template, this.templates.data);		
	}
	this.renderForecast = function() {
		var template = this.templates.tpls.forecast.innerHTML;
		var i = j = k = 0;
		var prevVal = null;
		$.each(this.forecast.forecast, $.proxy(function(key, val) {	
			if (this.isDateDiff(val, prevVal)) {
				i++;
				k = 0;
			}
			prevVal = val;
			var rec = this.getDateFrc(val.valid);
			this.setTemplateData(val, 'forecast');
			//templates.data['addled'] = '';
			//if (this.isAddledDate(val.valid)) templates.data['addled'] = 'addled';
			if (typeof this.templates.data['day'+i] == 'undefined') this.templates.data['day'+i] = '';
			this.templates.data['index'] = j;
			this.templates.data['day'+i] += this.templates.loadTpl(template, this.templates.data);
			this.setLegend(i, k, rec);
			j++;	
			k++;					 
		}, this));		
	}
	this.setTemplateData = function(data, ident) {
		ident = '_' + ident;
		this.templates.data['ct'+ident] = (this.params.deg == 'C'?data.t:Math.round(data.t*1.8+32));
		this.templates.data['deg'] = this.params.deg;	
		var plus = this.templates.data['ct'+ident]>=0?(this.templates.data['ct'+ident]!=0?'+':''):'&minus;';
		this.templates.data['ct'+ident] = plus+Math.abs(this.templates.data['ct'+ident])+(ident == 'forecast'?'&nbsp;':'');
		this.templates.data['hint'+ident] = this.getHint(data);
		this.templates.data['cl'+ident] = (data.cl!=''?('_'+data.cl):'');	
		this.templates.data['pt'+ident] = (data.pt!=''?('_'+data.pt):'');	
		this.templates.data['pr'+ident] = (data.pr!=''?data.pr:'');	
		this.templates.data['st'+ident] = (data.st!=''?('_'+data.st):'');		
		this.templates.data['star'+ident] = (data.icon!=''?('_'+data.icon):'');	
		this.templates.data['hi'] = (this.params.deg == 'C'?data.hi:Math.round(data.hi*1.8+32));
		var plus = this.templates.data['hi']>=0?(this.templates.data['hi']!=0?'+':''):'&minus;';
		this.templates.data['hi'] = plus+Math.abs(this.templates.data['hi']);
		this.templates.data['ws'] = (this.params.wind == 'm'?data.ws:Math.round(data.ws*3.6));
		this.templates.data['meter'] = this.dict.params[this.params.wind];
		this.templates.data['wd'] = (data.ws>0?this.dict.wdirs['w'+data.wd]:this.dict.wdirs.w9);
		this.templates.data['press'] = (this.params.press == 'mmHg'?data.p:Math.round(data.p/0.75));
		this.templates.data['press_unit']  = this.dict.params[this.params.press]['unit'];
		this.templates.data['press_unit_part2']  = this.dict.params[this.params.press]['unit_part2'];
		this.templates.data['hum'] = data.hum;		
		
		try {
			var str  = data.valid.replace("T"," ").split(" ");
    	var time = (str[1].match(/\d+/).toString());
			this.templates.data['tod_hour'] = time;
			this.templates.data['tod_minute'] = '00';
		}	
		catch(err) {}	
	}
	this.getHint = function(data) {
			var c = (data.cl!=''?data.cl:'c');
			var pr = (data.pr==''?'pr0':('pr'+data.pr)); 
			var hint = this.dict.phenomens[c]+
																	((pr != 'pr0' && pr != 'pr2')||(data.pt!="")?', ':'')+
																	this.dict.phenomens[pr]+
																	(data.pt!=''?' '+this.dict.phenomens[data.pt]:'')+
																	(data.st!=''?', '+this.dict.phenomens['st']:'');
			return hint;
	}		
	this.getPhotoPict = function(data) {
		if(data.icon == 'd') data.icon = 0;
		if(data.icon == 'n') data.icon = 1;		
		if (data.cl == 'c4') data.icon = 2;
		if (data.cl == '') data.cl = 0;
		if (data.cl == 'c2') data.cl = 1;
		if (data.cl == 'c3') data.cl = 2;
		if (data.cl == 'c4') data.cl = 3;
		this.templates.data['star_photoreal'] = data.icon;	 		 		 
		this.templates.data['cl_photoreal'] = data.cl;
		if (data.pt == '') data.pt = 0;
		if (data.pt == 'r') {
			if (data.pr == 1) data.pt = 1;
			if (data.pr == 2) data.pt = 2;
			if (data.pr >2) data.pt = 4;									
		}
		if (data.pt == 's') {
			if (data.pr == 1) data.pt = 5;
			if (data.pr == 2) data.pt = 6;
			if (data.pr >2) data.pt = 8;									
		}	
		if ((data.cl == 1 || data.cl == 2) && data.pt>0 ) this.templates.data['cl_photoreal'] = 3;  			
		this.templates.data['pt_photoreal'] = data.pt;
		if (data.st == 'st') data.st = 1;
		else data.st = 0;
		this.templates.data['st_photoreal'] = data.st;	
	}
	this.getDateFrc = function(val) {
		var str  = val.replace("T"," ").split(" ");
		var date = new Date(str[0].replace(/(\d+)-(\d+)-(\d+)/, '$2/$3/$1'));
		var time = str[1].match(/\d+/).toString();
		var rec = {};
		rec.day = date.getDay();
		rec.date = date.getDate();
		rec.month = date.getMonth();
		rec.time =  time+':00';
		return rec;
	}	
	this.isDateDiff = function(val, prevVal) { 
		if (!prevVal) return false;
		var date = new Date(val.valid.replace(/(\d+)-(\d+)-(\d+)/, '$2/$3/$1').replace("T"," "));
		var old_date = new Date(prevVal.valid.replace(/(\d+)-(\d+)-(\d+)/, '$2/$3/$1').replace("T"," "));
		if (date.getDate() !=  old_date.getDate()) return true;
		else return false;					
	}
	this.setFrcTemperPos = function() {
			this.rec = [];		
			var maxTop = 0;	
			$.each(this.forecast.forecast, $.proxy(function(key, val) {
				if (parseInt(val.t, 10) < this.minT) this.minT = val.t;
				if (parseInt(val.t, 10) > this.maxT) this.maxT = val.t;				
			}, this));				
			//var height = Math.round($('.forecast .temper').height());
			var height = 32;
			var minTop = height*this.step;
			var pos = delta = 0;
			$.each(this.forecast.forecast, $.proxy(function(index) {
				var graph = {delta: 0, r: null, g: null, b: null};
				if (this.maxT != this.minT) pos = Math.round((minTop-maxTop)*((this.maxT-this.minT-(this.forecast.forecast[index].t-this.minT))/(this.maxT-this.minT)));
				if (this.docObj.getElementById('forecast_temper'+index)) {
					this.docObj.getElementById('forecast_temper'+index).style.paddingTop = pos;
				}
				else $('.forecast .temper:eq('+index+')').css('padding-top', pos+'px');
				graph.delta = pos - delta;
				delta = pos;
				this.rec[index] = graph;
			}, this));				
	}
	this.setColorGraph = function() {
		var temp = [
	   {val:100, r:255, g:0, b:0},			
	   {val:40, r:255, g:0, b:0},
	   {val:30, r:255, g:120, b:0},
	   {val:20, r:255, g:211, b:0},
	   {val:10, r:104, g:217, b:16},
	   {val:1, r:200, g:239, b:167},
	   {val:0, r:200, g:240, b:255},
	   {val:-10, r:32, g:197, b:255},
	   {val:-20, r:16, g:69, b:255},
	   {val:-30, r:103, g:0, b:249},
	   {val:-40, r:86, g:0, b:175},
	   {val:-100, r:86, g:0, b:175}		   
	  ];
		var n = 1;
		var j = 0;
		var finishPercent = j/n;
		var startPercent = 1 - finishPercent; 
		var R,G,B;
		var index = 0;
		var arr = [];
		$.each(this.forecast.forecast, function(key, val) {
			arr.push(val);
		});			
		if (typeof(arr) == 'undefined') return;					
		var len = arr.length;
		$.each(arr, $.proxy(function(key, val) {
			for (var i=0; i<temp.length-1; i++) {
				if (parseInt(val.t, 10)>temp[i+1].val && parseInt(val.t, 10)<=temp[i].val) {
					n = Math.abs(temp[i].val-temp[i+1].val);
					j = Math.abs(temp[i].val-parseInt(val.t, 10));
					finishPercent = j/n;
					startPercent = 1 - finishPercent;
					//if (this.isAddledDate(val.valid))
						//R = G = B = 100;
					//else {
						R = Math.floor((temp[i].r) * startPercent + (temp[i+1].r) * finishPercent );
						G = Math.floor((temp[i].g) * startPercent + (temp[i+1].g) * finishPercent );
						B = Math.floor((temp[i].b) * startPercent + (temp[i+1].b) * finishPercent );
					//}
					try {
						this.rec[index].r = R;
						this.rec[index].g = G;
						this.rec[index].b = B;
						this.rec[index].t = val.t;
					}
					catch(e) {}
				}
			}
			index++;
		}, this));	
	}	
	this.setGraph = function() {
		var arr = this.rec;
		var context = this;	
		$.each(arr, function(index) {
			if (context.template == 'undock') {
				$('.graph:eq('+index+') .val').css('border-top', '1px solid rgb('+this.r+','+this.g+','+this.b+')');
				$('.graph:eq('+index+') .val').css('font-size', '0');	
			}
			else {
				if (context.docObj.getElementById('val'+index))  {
						context.docObj.getElementById('val'+index).style.borderTop = '1px solid rgb('+this.r+','+this.g+','+this.b+')';
						context.docObj.getElementById('val'+index).style.fontSize = 0; 					 					
				}	
			}
			if (index>0 && this.delta!==0) {
				if (context.template == 'undock') {
					$('.graph:eq('+index+') .right-border.first').css({
						'font-size': 0,			
						'height': Math.abs(Math.ceil(this.delta/2))+'px',
						'top': ((this.delta>0)?((Math.abs(this.delta))*-1):1)+'px',
						'background-color': (arr[index-1].t>this.t?'rgb('+arr[index-1].r+','+arr[index-1].g+','+arr[index-1].b+')':'rgb('+this.r+','+this.g+','+this.b+')')
					});
					$('.graph:eq('+index+') .right-border:last').css({
						'font-size': 0,			
						'height': Math.abs(this.delta)+'px',
						'top': ((this.delta>0)?((Math.abs(this.delta))*-1):1)+'px',
						'background-color': (arr[index-1].t<this.t?'rgb('+arr[index-1].r+','+arr[index-1].g+','+arr[index-1].b+')':'rgb('+this.r+','+this.g+','+this.b+')')
					});					
				}
				else {				
					var o = context.docObj.getElementById('right-border'+index);
					if (o)  {
						with(o.style) {
							height = Math.abs(this.delta/2)+'px';
							top = ((this.delta>0)?((Math.abs(this.delta))*-1):1)+'px';
							fontSize = 0;
							backgroundColor = (arr[index-1].t>this.t?'rgb('+arr[index-1].r+','+arr[index-1].g+','+arr[index-1].b+')':'rgb('+this.r+','+this.g+','+this.b+')');
						}					 					
					}
					o = context.docObj.getElementById('right-border-2'+index);
					if (o)  {
						with(o.style) {
							height = Math.abs(this.delta)+'px';
							top = ((this.delta>0)?((Math.abs(this.delta))*-1):1)+'px';
							fontSize = 0;
							backgroundColor = (arr[index-1].t<this.t?'rgb('+arr[index-1].r+','+arr[index-1].g+','+arr[index-1].b+')':'rgb('+this.r+','+this.g+','+this.b+')');
						}					 					
					}					
				}				
			}
		});
	}
	this.setLegend = function(i, count, rec) {
		var template = this.templates.tpls.legend.innerHTML;
		this.templates.data['month'] = '';
		this.templates.data['weekday'] = this.dict.weekdays['w'+rec.day];
		this.templates.data['month'] = this.dict.minMonthes['m'+rec.month];
		this.templates.data['day'] = rec.date;
		this.templates.data['date'+i] = this.templates.loadTpl(template, this.templates.data);
	}	
	this.getCurrentDatetime = function(value) {
		if (!value) value = 0;
		var record = {};
		if (!this.utc) return record;
		var now = new Date();	
		now.setTime(this.utc.time.getTime() + value);
		record.day = now.getDay();
		record.date = now.getDate();
		record.month = now.getMonth();
		record.hour = now.getHours();
		record.minutes = now.getMinutes();
		if (record.minutes.toString().length == 1) record.minutes = '0' + record.minutes;
		record.time = now.getTime();
		return record;
	}		
	this.renderFromCity = function(forecast) {
		this.writeLog('forecast', $.toJSON(forecast));	
	}	
	this.getRootUrl =  function(url) {
  	return url.toString().replace(/^(.*\/\/[^\/?#]*).*$/,"$1");
	}	
	this.init($.proxy(function(){	
		this.templates.tpls = {
			dock: this.docObj.getElementById('dock'), 
			undock: this.docObj.getElementById('undock'), 
			undock_flyout: this.docObj.getElementById('undock'), 
			fact: this.docObj.getElementById('fact_content'), 
			forecast: this.docObj.getElementById('frc_content'), 
			legend: this.docObj.getElementById('legend'), 
			city: this.docObj.getElementById('city_content')
		};
		this.renderGadget();
	}, this));
}